<?php

    namespace Modules\Lpj\Http\Controllers;

    use App\Http\Controllers\Controller;
    use Exception;
    use Illuminate\Http\Request;
    use Maatwebsite\Excel\Facades\Excel;
    use Modules\Lpj\Exports\CustomFieldExport;
    use Modules\Lpj\Http\Requests\CustomFieldRequest;
    use Modules\Lpj\Models\CustomField;

    class CustomFieldController extends Controller
    {
        public $user;

        public function index()
        {
            return view('lpj::custom_fields.index');
        }

        public function store(CustomFieldRequest $request)
        {
            $validate = $request->validated();

            if ($validate) {
                try {
                    // Save to database
                    CustomField::create($validate);
                    return redirect()
                        ->route('basicdata.custom-field.index')
                        ->with('success', 'Custom Field created successfully');
                } catch (Exception $e) {
                    return redirect()
                        ->route('basicdata.custom-field.create')
                        ->with('error', $e->getMessage());
                }
            }
        }

        public function create()
        {
            $urutan_prioritas = CustomField::max('urutan_prioritas')+1;
            return view('lpj::custom_fields.create', compact('urutan_prioritas'));
        }

        public function edit($id)
        {
            $customField = CustomField::find($id);
            $urutan_prioritas = $customField->urutan_prioritas ?? CustomField::max('urutan_prioritas')+1;
            return view('lpj::custom_fields.create', compact('customField', 'urutan_prioritas'  ));
        }

        public function update(CustomFieldRequest $request, $id)
        {
            $validate = $request->validated();

            if ($validate) {
                try {
                    // Update in database
                    $customField = CustomField::find($id);
                    $customField->update($validate);
                    return redirect()
                        ->route('basicdata.custom-field.index')
                        ->with('success', 'Custom Field updated successfully');
                } catch (Exception $e) {
                    return redirect()
                        ->route('basicdata.custom-field.edit', $id)
                        ->with('error', 'Failed to update custom field');
                }
            }
        }

        public function destroy($id)
        {
            try {
                // Delete from database
                $customField = CustomField::find($id);
                $customField->delete();

                echo json_encode(['success' => true, 'message' => 'Custom Field deleted successfully']);
            } catch (Exception $e) {
                echo json_encode(['success' => false, 'message' => 'Failed to delete custom field']);
            }
        }

        public function dataForDatatables(Request $request)
        {
            if (is_null($this->user) || !$this->user->can('custom_fields.view')) {
                //abort(403, 'Sorry! You are not allowed to view custom fields.');
            }

            // Retrieve data from the database
            $query = CustomField::query();

            // Apply search filter if provided
            if ($request->has('search') && !empty($request->get('search'))) {
                $search = $request->get('search');
                $query->where(function ($q) use ($search) {
                    $q->where('name', 'LIKE', "%$search%");
                    $q->orWhere('label', 'LIKE', "%$search%");
                    $q->orWhere('type', 'LIKE', "%$search%");
                });
            }

            // Apply sorting if provided
            if ($request->has('sortOrder') && !empty($request->get('sortOrder'))) {
                $order  = $request->get('sortOrder');
                $column = $request->get('sortField');
                $query->orderBy($column, $order);
            }

            // Get the total count of records
            $totalRecords = $query->count();

            // Apply pagination if provided
            if ($request->has('page') && $request->has('size')) {
                $page   = $request->get('page');
                $size   = $request->get('size');
                $offset = ($page - 1) * $size; // Calculate the offset

                $query->skip($offset)->take($size);
            }

            // Get the filtered count of records
            $filteredRecords = $query->count();

            // Get the data for the current page
            $data = $query->get();

            // Calculate the page count
            $pageCount = ceil($totalRecords / $request->get('size'));

            // Calculate the current page number
            $currentPage = 0 + 1;

            // Return the response data as a JSON object
            return response()->json([
                'draw'            => $request->get('draw'),
                'recordsTotal'    => $totalRecords,
                'recordsFiltered' => $filteredRecords,
                'pageCount'       => $pageCount,
                'page'            => $currentPage,
                'totalCount'      => $totalRecords,
                'data'            => $data,
            ]);
        }

        public function export()
        {
            return Excel::download(new CustomFieldExport, 'custom_fields.xlsx');
        }
    }
